#!/usr/bin/perl
#
# Usage:
#
#    wineenv.pl <environment_name>
#
#    1) The first time what you run with a "environment_name", the 
#       fake_windows, and config files are made for this environtment
#       and it is set to the active environment.
#
#    2) The next times what you run with that "environment_name", it is
#       set to the active environment.
#
# Example:
#
#    wineenv.pl fifa99
#

#
# Name of the environment
#
$envname   = join "",@ARGV;
$envname   =~ s/ //g;

#
# User Home
#
$myhome    = $ENV{HOME};

#
# Regedit path (Ex. "/usr/local/bin/regedit")
#
$regedit   = "";

#
# Winedefault.reg path (Ex. "/mnt4/calb/wine/wine/winedefault.reg")
#
$winereg   = "";

#
# Base path for the fakewindows (Ex. "/mnt4/calb/wine/wineenv")
#
$envbasepath = "";

#### Check vars ####

if ($envname eq "") {
   print "Usage: wineenv.pl <environment_name>\n";
   exit;
}

if ($regedit eq "") {
   print "Error: regedit path not found, set it in wineenv.pl\n";
   exit;
}

if ($winereg eq "") {
   print "Error: winedefault.reg path not found, set it in wineenv.pl\n";
   exit;
}

if ($envbasepath eq "") {
   print "Error: fakewindow base path not found, set it in wineenv.pl\n";
   exit;
}

if ( ! -d "$envbasepath" ) {
   print "Error: fakewindow base path is not a directory\n";
   exit;
}

if ($myhome eq "") {
   print "Error: home directory path not found, set it in wineenv.pl\n";
   exit;
}

#### Main program ####

if ( -d "$envbasepath/$envname" ) {

    unlink( "$myhome/.wine" );
    symlink( "$myhome/.wineenv/$envname","$myhome/.wine" ); 

    print "Active environment [$envname]\n";

} else {

    print "Environment [$envname] not found, create now? (y/N) ";
    chomp($answer = <STDIN>);
                                                                                
    if ($answer =~ /(^y|^Y)/) {

    mkdir( "$envbasepath/$envname" );
    mkdir( "$envbasepath/$envname/windows" );
    mkdir( "$envbasepath/$envname/windows/system" );
    mkdir( "$envbasepath/$envname/windows/fonts" );
    mkdir( "$envbasepath/$envname/temp" );
    mkdir( "$myhome/.wineenv/$envname" );

    $origfile = "$myhome/.wineenv/config";

    open( FILE, $origfile ) || die "Original wine config file not found";
    @lines = <FILE>;
    $lines = join( "", @lines );
    close (FILE);

    $lines =~ s/DRIVEPATH/$envbasepath\/$envname/g;

    $configfile = "$myhome/.wineenv/$envname/config";
    open( FILE, ">$configfile" ) || die "Cannot write the wine config file";
    print FILE $lines;
    close( FILE );

    unlink( "$myhome/.wine" );
    symlink("$myhome/.wineenv/$envname","$myhome/.wine" );
    system( "/bin/cp $winereg \"$envbasepath/$envname\"" );
    system( "cd \"$envbasepath/$envname\"; $regedit winedefault.reg" );
    unlink( "$envbasepath/$envname/winedefault.reg" );
    print "Active environment [$envname]\n";
    }
}

